function hcGetBundle(id) {
	try {
		var txt = document.getElementById("hcBundle").getString("HandCoder-" + id);
	} catch (e) {
		var txt = id;
	}
	return txt;
}

var hcModif = {
	urls : new Array(),
	dates : new Array(),
	focus : true,
	
	getLast : function(url) {
		// ref = http://www.xulplanet.com/references/xpcomref/comps/c_filelocal1.html
		var time = 0;
		if (!url)
			url = GetDocumentUrl();
			//~ url = unescape(GetDocumentUrl());
		
		try {
			url = url.replace(cgiREPLACE, "$1"); // in case this is a template file
			var path = KazIO.urlToPath(url);
			var file = KazIO._newLocalFile(path);
			time = file.lastModifiedTime;
		} catch (e) {}
		return time;
	},
	
	store : function(url) {
		url = unescape(url);
		
		// get "last modified" time for the current url
		//~ var lastMod = this.getLast(url);
		var lastMod = 0;
		try {
			url = url.replace(cgiREPLACE, "$1"); // in case this is a template file
			var path = KazIO.urlToPath(url);
			var file = KazIO._newLocalFile(path);
			lastMod = file.lastModifiedTime;
		} catch (e) {}
		
		// look for the current url in the 'urls' array
		var found = false;
		for (var i = 0; i < this.urls.length; i++) 
			if (this.urls[i] == url) {
				found = true;
				this.dates[i] = lastMod;
				break;
			}
		if (!found) {
			this.urls.push(url);
			this.dates.push(lastMod);
		}
		return lastMod;
	},
	
	find : function(url) {
		url = unescape(url);
		// get last modification date
		var lastMod = 0;
		for (var i = 0; i < this.urls.length; i++) 
			if (this.urls[i] == url) {
				lastMod = this.dates[i];
				break;
			}
		return lastMod;
	},
	
	check : function(url) {
		if ( (url == "about:blank") || (GetScheme(url) != "file") || (!this.focus) )
			return;
		
		// reset globals
		var lastMod = this.find(url);
		var current = this.store(url);
		//~ var current = getLastMod(unescape(url));
		//~ var lastMod = NsmExternalEditorLastMod;
		//~ NsmExternalEditorLastMod = 0;
		//~ NsmEditorAppRef = -1;
		
		// test if the file has been modified
		if ( (lastMod > 0) && (lastMod != current) ) {
//~ KazIO.trace(this.urls);
//~ KazIO.trace(this.dates);
//~ KazIO.trace(url + "\n" + lastMod + "\n" + current);
			// file has been modified, ask whether to accept or reject modifications
			if (ConfirmWithTitle("HandCoder", 
				hcGetBundle("Edit-Warning"), 
				hcGetBundle("Edit-Accept"), 
				hcGetBundle("Edit-Discard") ) 
			) { // Accept changes
				CancelHTMLSource(); // useless?
				url = phpIO.Reload(url); // in case this is a template file
				EditorLoadUrl(url); // reload document in Nvu
				//~ storeLastMod(unescape(url));
			} else { // Discard changes
				nsSaveCommand.doCommand(); // save Nvu's document to discard changes
			}
		}
		return;
	}
}

//
// Modified functions (override those in 'comm.jar/editor/content/publishprefs.js') to work with 'file://' urls.
function FindSiteIndexAndDocDir(publishSiteData, docUrl, dirObj) {
// Find index of a site record in supplied publish site database
// docUrl: Document URL with or without filename
//         (Must end in "/" if no filename)
// dirObj.value =  the directory of the document URL 
//      relative to the base publishing URL, using "" if none
//
// XXX: Currently finds the site with the longest-matching url;
//      should we look for the shortest instead? Or match just the host portion?

  if (dirObj)
    dirObj.value = "";
    
  // Kaze
  //~ if (!publishSiteData || !docUrl || GetScheme(docUrl) == "file")
  if (!publishSiteData || !docUrl)
    return -1;

  var siteIndex = -1;
  var siteUrlLen = 0;
  
  for (var i = 0; i < publishSiteData.length; i++)
  {
    // Site publish or browse url needs to be contained in document URL,
    //  but that may also have a directory after the site base URL
    //  So we must examine all records to find the site URL that best
    //    matches the document URL: the longest-matching substring (XXX is this right?)
    var lenObj = {value:0};
    var tempData = Clone(publishSiteData[i]);

    // Check if this site matches docUrl (returns length of match if found)
    var len = FillInMatchingPublishData(tempData, docUrl);

    if (len > siteUrlLen)
    {
      siteIndex = i;
      siteUrlLen = len;
      if (dirObj)
        dirObj.value = tempData.docDir;

      // Continue to find the site with longest-matching publishUrl
    }
  }
  return siteIndex;
}
function CreatePublishDataFromUrl(docUrl) {
  // Kaze
  //~ if (!docUrl || IsUrlAboutBlank(docUrl) || GetScheme(docUrl) == "file")
  if (!docUrl || IsUrlAboutBlank(docUrl))
    return null;

  var pubSiteData = GetPublishSiteData();
  if (pubSiteData) {
    var dirObj = {};
    var index = FindSiteIndexAndDocDir(pubSiteData, docUrl, dirObj);
    var publishData;
    // Kaze
    //~ if (index != -1) {
    if ( (index != -1) && (pubSiteData[index].browseUrl != "http://") ) {
      publishData = pubSiteData[index];
      publishData.docDir = FormatDirForPublishing(dirObj.value)

      //XXX Problem: OtherDir: How do we decide when to use the dir in 
      //    publishSiteData (default DocDir) or docDir from current filepath?
      publishData.otherDir = FormatDirForPublishing(pubSiteData[index].otherDir);

      publishData.filename = GetFilename(docUrl);
      publishData.notInSiteData = false;
      return publishData;
    }
  }

  // Document wasn't found in publish site database
  // Create data just from URL

  // Extract username and password from docUrl
  var userObj = {};
  var passObj = {};
  var pubUrl = StripUsernamePassword(docUrl, userObj, passObj);

  // Strip off filename
  var lastSlash = pubUrl.lastIndexOf("\/");
  //XXX Look for "?", "=", and "&" ?
  pubUrl = pubUrl.slice(0, lastSlash+1);

  var siteName = CreateSiteNameFromUrl(pubUrl, pubSiteData);

  publishData = { 
    siteName : siteName,
    previousSiteName : siteName,
    filename : GetFilename(docUrl),
    username : userObj.value,
    password : passObj.value,
    savePassword : false,
    publishUrl : pubUrl,
    browseUrl  : pubUrl,
    docDir     : "",
    otherDir   : "",
    publishOtherFiles : true,
    dirList    : [""],
    saveDirs   : false,
    notInSiteData : true
  }

  return publishData;
}
function url2http(url) {
	var publishData = CreatePublishDataFromUrl(url);
	if (publishData && publishData.filename && publishData.publishUrl)
		url = publishData.browseUrl + publishData.docDir + publishData.filename;
	return url;
}
//
// Modified 'editPage' function (override that in 'comm.jar/editor/content/editorApplicationOverlay.js')
function editPage(url, launchWindow, delay, newTab) {
/* Any non-editor window wanting to create an editor with a URL should use this instead of "window.openDialog..."
 * We must always find an existing window with requested URL
 * (When calling from a dialog, "launchWindow" is dialog's "opener" and we need a delay to let dialog close) */
 
  // Always strip off "view-source:" and #anchors
  url = url.replace(/^view-source:/, "").replace(/#.*/, "");
  
	// <Kaze> allow to open PHP files
	var result = phpIO.Split(url);
	if (result)
		url = result;
	else {
		hcLaunchEditor(url);
		// useless (bug remains)
		//~ EnableAllUI(true);
		//~ try { // ends the Site Manager navigation callback
			//~ window.top.document.getElementById("tabeditor").endNavigationCallback = EndNavigation;
		//~ } catch (e) {}
		return;
	}
	// remember modification date
	//~ storeLastMod(url);
	// </Kaze>
	
  // User may not have supplied a window
  if (!launchWindow)
  {
    if (window)
    {
      launchWindow = window;
    }
    else
    {
      dump("No window to launch an editor from!\n");
      return;
    }
  }

  // if the current window is a browser window, then extract the current charset menu setting from the current 
  // document and use it to initialize the new composer window...

  var wintype = document.firstChild.getAttribute('windowtype');
  var charsetArg;

  if (launchWindow && (wintype == "navigator:browser") && launchWindow.content.document)
    charsetArg = "charset=" + launchWindow.content.document.characterSet;

  try {
    var uri = createURI(url, null, null);

    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    var enumerator = windowManagerInterface.getEnumerator( "composer:html" );
    var emptyWindow;
    while ( enumerator.hasMoreElements() )
    {
      var win = enumerator.getNext().QueryInterface(Components.interfaces.nsIDOMWindowInternal);
      if ( win && win.IsWebComposer())
      {
        if (!newTab && CheckOpenWindowForURIMatch(uri, win))
        {
          // We found an editor with our url
          win.focus();
          return;
        }
        if (!emptyWindow && win.PageIsEmptyAndUntouched())
        {
          emptyWindow = win;
        }
      }
    }

    if (newTab && win)
    {
      win.document.getElementById("tabeditor").editURL(url, false, false, false);
      win.focus();
      return;
    }

    if (emptyWindow)
    {
      // we have an empty window we can use
      if (emptyWindow.IsInHTMLSourceMode())
        emptyWindow.SetEditMode(emptyWindow.PreviousNonSourceDisplayMode);
      emptyWindow.EditorLoadUrl(url);
      emptyWindow.focus();
      emptyWindow.SetSaveAndPublishUI(url);
      return;
    }

    // Create new Composer window
    if (delay)
    {
      launchWindow.delayedOpenWindow("chrome://editor/content", "chrome,all,dialog=no", url);
    }
    else
      launchWindow.openDialog("chrome://editor/content", "_blank", "chrome,all,dialog=no", url, charsetArg);

  } catch(e) {}
}

//
// Modified 'CheckAndSaveDocument' function (override that in 'comm.jar/editor/content/editor.js') to remove temp files
function CheckAndSaveDocument(command, allowDontSave) {
	// Kaze
	if (command == "cmd_close") {
		phpIO.unlinkTemp(GetDocumentUrl());
	}
	
  var document;
  try {
    // if we don't have an editor or an document, bail
    var editor = GetCurrentEditor();
    document = editor.document;
    if (!document)
      return true;
  } catch (e) { return true; }

  if (!IsDocumentModified() && !IsHTMLSourceChanged())
    return true;

  // call window.focus, since we need to pop up a dialog
  // and therefore need to be visible (to prevent user confusion)
  top.document.commandDispatcher.focusedWindow.focus();  

  var scheme = GetScheme(GetDocumentUrl());
  var doPublish = (scheme && scheme != "file");

  var strID;
  switch (command)
  {
    case "cmd_close":
      strID = "BeforeClosing";
      break;
    case "cmd_preview":
      strID = "BeforePreview";
      break;
    case "cmd_editSendPage":
      strID = "SendPageReason";
      break;
    case "cmd_validate":
      strID = "BeforeValidate";
      break;
  }
    
  var reasonToSave = strID ? GetString(strID) : "";

  var title = document.title;
  if (!title)
    title = GetString("untitled");

  var dialogTitle = GetString(doPublish ? "PublishPage" : "SaveDocument");
  var dialogMsg = GetString(doPublish ? "PublishPrompt" : "SaveFilePrompt");
  dialogMsg = (dialogMsg.replace(/%title%/,title)).replace(/%reason%/,reasonToSave);

  var promptService = GetPromptService();
  if (!promptService)
    return false;

  var result = {value:0};
  var promptFlags = promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1;
  var button1Title = null;
  var button3Title = null;

  if (doPublish)
  {
    promptFlags += promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0;
    button1Title = GetString("Publish");
    button3Title = GetString("DontPublish");    
  }
  else
  {
    promptFlags += promptService.BUTTON_TITLE_SAVE * promptService.BUTTON_POS_0;
  }

  // If allowing "Don't..." button, add that
  if (allowDontSave)
    promptFlags += doPublish ?
        (promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2)
        : (promptService.BUTTON_TITLE_DONT_SAVE * promptService.BUTTON_POS_2);
  
  result = promptService.confirmEx(window, dialogTitle, dialogMsg, promptFlags,
                          button1Title, null, button3Title, null, {value:0});

  if (result == 0)
  {
    // Save, but first finish HTML source mode
    if (IsHTMLSourceChanged()) {
      try {
        FinishHTMLSource();
      } catch (e) { return false;}
    }

    if (doPublish)
    {
      // We save the command the user wanted to do in a global
      // and return as if user canceled because publishing is asynchronous
      // This command will be fired when publishing finishes
      gCommandAfterPublishing = command;
      goDoCommand("cmd_publish");
      return false;
    }

    // Save to local disk
    var contentsMIMEType;
    if (IsHTMLEditor())
      /*if (IsXHTMLDocument())
        contentsMIMEType = kXMLMimeType;
      else*/
        contentsMIMEType = kHTMLMimeType;
    else
      contentsMIMEType = kTextMimeType;
/*     var success, nvusave;
    // XX - Nvu Save Extension change
    // If the extension is installed, call our version of Save Document
    try {
      nvusave = saveExtensionOn;
    }
    catch (e)  {
      nvusave = false;   // not defined
    }
    if (nvusave)
      success = NvuSaveDocument(false, false, contentsMIMEType);
    else
      success = SaveDocument(false, false, contentsMIMEType); */
      
      // Kaze
      success = NsmSaveDocument(false, false, contentsMIMEType);
      
    return success;
  }

  if (result == 2) // "Don't Save"
    return true;

  // Default or result == 1 (Cancel)
  return false;
}
//
// Modified 'nsPreviewCommand' and 'nsRevertCommand' commands (override those in 'comm.jar/editor/content/ComposerCommands.js')
var NsmPreviewAppRef = -1;
nsPreviewCommand.doCommand = function(aCommand) {
	if (NsmPreviewAppRef < -1)
		return;
	
	// Don't continue if user canceled during prompt for saving
	// DocumentHasBeenSaved will test if we have a URL and suppress "Don't Save" button if not
	if (!CheckAndSaveDocument("cmd_preview", DocumentHasBeenSaved()))
		return;
		
	// Check if we saved again just in case?
	if (DocumentHasBeenSaved()) {
		var url = GetDocumentUrl();
		url = phpIO.Merge(url);
		url = url2http(url);
		
		if (NsmPreviewAppRef >= 0) { // launch custom browser
			NsmLaunch(NsmPreviewAppRef, url);
			NsmPreviewAppRef = -1; // reset to default browser
		} else { // launch default browser
			loadExternalURL(url);
		}
	}
}
// always enable 'cmd_revert' in case the current page has been modified with an external editor
nsRevertCommand.isCommandEnabled = function(aCommand, dummy) {
	return (IsDocumentEditable() && !IsUrlAboutBlank(GetDocumentUrl())	);
}
// 'cmd_revert' has yet to check if the current page is linked to a PHP template
nsRevertCommand.doCommand = function(aCommand) {
	// Confirm with the user to abandon current changes
	var promptService = GetPromptService();
	if (promptService) {
		// Put the page title in the message string
		var title = GetDocumentTitle();
		if (!title)
			title = GetString("untitled");
		
		var msg = GetString("AbandonChanges").replace(/%title%/,title);
		
		var result = 0; // Kaze: prompt only if document is modified
		if (IsDocumentModified())
			result = promptService.confirmEx(window, GetString("RevertCaption"), msg,
				      (promptService.BUTTON_TITLE_REVERT * promptService.BUTTON_POS_0) +
				      (promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1),
				      null, null, null, null, {value:0});
		
		// Reload page if first button (Revert) was pressed
		if (result == 0) {
			CancelHTMLSource();
			// Kaze: in case the current document is a PHP template
			//~ EditorLoadUrl(GetDocumentUrl());
			var url = phpIO.Reload(GetDocumentUrl());
			EditorLoadUrl(url);
		}
		
	}
}
//
// Modified 'nsSaveCommand' and 'nsSaveAsCommand' commands (override those in 'comm.jar/editor/content/ComposerCommands.js')
nsSaveCommand.doCommand = function(aCommand) {
	var result = false;
	var editor = GetCurrentEditor();
	if (editor) {
		FinishHTMLSource();
		// for the time being, we use the HTML serializer
		var editorMimeType = editor.contentsMIMEType;
		if (editorMimeType == "application/xhtml+xml")
			editorMimeType = "text/html";
		//~ result = SaveDocument(IsUrlAboutBlank(GetDocumentUrl()), false, editorMimeType);
		result = NsmSaveDocument(IsUrlAboutBlank(GetDocumentUrl()), false, editorMimeType); // Kaze
		window.content.focus();
	}
	return result;
}

nsSaveAsCommand.doCommand = function(aCommand) {
	var editor = GetCurrentEditor();
	if (editor) {
		FinishHTMLSource();
		//~ var result = SaveDocument(true, false, editor.contentsMIMEType);
		var result = NsmSaveDocument(true, false, editor.contentsMIMEType); // Kaze
		window.content.focus();
		return result;
	}
	return false;
}

function NsmSaveDocument(aSaveAs, aSaveCopy, aMimeType) {
	var url = GetDocumentUrl();
	var editUrl = url;
	//~ var editUrl = "";
//~ KazIO.trace("Saving file '" + editUrl + "'");
	hcModif.focus = false;
	
	// Save the document (Nvu function)
	var result = SaveDocument(aSaveAs, aSaveCopy, aMimeType);
	
	// Tidy and merge file
	if (result) {
		//~ var url = GetDocumentUrl();
		//~ editUrl = url;
		try {
			var tidy = (hcPrefs.getCharPref("tidyLaunch") == NsmTIDY_OnSave);
//~ KazIO.trace(tidy, "tidy");
		} catch (e) {}
		
		if (phpIO.isFragment(url)) {
			editUrl = phpIO.Merge(url); // merge splitted file whithout formatting
			if (tidy)	// try to reformat the <body> content
				hcLaunchTidy(url, editUrl, true);
		} else {
			if (tidy)
				hcLaunchTidy(url);
			editUrl = phpIO.Merge(url); // merge splitted file if necessary
		}
	}
	
	// remember modification date
//~ KazIO.trace("Saving file, " + hcModif.store(editUrl));
	hcModif.store(editUrl);
	hcModif.focus = true;
	
	return result;
}
//
// Editor toolbar button
//~ var NsmEditorAppRef = NsmTIDY_OnSource;
var NsmEditorAppRef = -1;
function NsmEditPage(e) {
	var url = GetDocumentUrl();
	var editUrl = "";
	var appRef = NsmEditorAppRef;
	NsmEditorAppRef = -1; // disable this line to keep the last selected editor as default editor
	
	// check event and URL
	//~ if (e)
		//~ if ((url == "about:blank") || (e.button != 0))
			//~ return;
	if ((url == "about:blank") || (GetScheme(url) != "file") || (appRef < -1))
		return;
		
	// save document if needed
	if (!(CheckAndSaveDocument("", false)))
		return;
	
	// tidy file (if requested in the prefs) and merge it if needed
	try {
		var tidy = (hcPrefs.getCharPref("tidyLaunch") == NsmTIDY_OnSource);
	} catch (e) {}
	
	if (phpIO.isFragment(url)) {
		editUrl = phpIO.Merge(url); // merge splitted file whithout formatting
		if (tidy)	// try to reformat the <body> content
			hcLaunchTidy(url, editUrl, true);
	} else {
		if (tidy)
			hcLaunchTidy(url);
		editUrl = phpIO.Merge(url); // merge splitted file if necessary
	}
	
	// remember modification date
	//~ NsmExternalEditorLastMod = getLastMod();
	if (appRef >= 0)
		NsmLaunch(appRef, editUrl); // Launch selected editor (requires NsmConText)
	else
		hcLaunchEditor(editUrl);
	
	return;
}
//
// Editor toolbar button
function NsmLaunchTidy(e) {
	var url = GetDocumentUrl();
	var editUrl = "";
	
	// check event and URL
	//~ if (e)
		//~ if ((url == "about:blank") || (e.button != 0))
			//~ return;
	if ((url == "about:blank") || (GetScheme(url) != "file"))
		return;
		
	// save document if needed
	if (!(CheckAndSaveDocument("", false)))
		return;
	
	// tidy file and merge it if needed
	if (phpIO.isFragment(url)) {
		editUrl = phpIO.Merge(url); // merge splitted file whithout formatting
		hcLaunchTidy(url, editUrl, true);
	} else {
		hcLaunchTidy(url);
		editUrl = phpIO.Merge(url); // merge splitted file if necessary
	}
	
	// remember modification date
	hcModif.store(url);
	
	return;
}
//
// Modified 'EditorOnFocus' function (override that in 'comm.jar/editor/content/editor.js')
// for user notification after an external editor is launched
/* disabled!
function EditorOnBlur() {
	//~ cmd_setDocumentModified
        document.getElementById("tabeditor").showCurrentTabAsModified(true);
	//~ alert("leaving Nvu...");
} */
function EditorOnFocus() {
  // Current window already has the InsertCharWindow
  if ("InsertCharWindow" in window && window.InsertCharWindow) return;

  // Find window with an InsertCharsWindow and switch association to this one
  var windowWithDialog = FindEditorWithInsertCharDialog();
  if (windowWithDialog)
  {
    // Switch the dialog to current window
    // this sets focus to dialog, so bring focus back to editor window
    if (SwitchInsertCharToThisWindow(windowWithDialog))
      top.document.commandDispatcher.focusedWindow.focus();
  }
  
	// <Kaze>
	// disable button if document is distant or blank
	var url = GetDocumentUrl();
	//~ var isBlank = ( (url == "about:blank") || (GetScheme(url) != "file") );
	hcModif.check(url);
	EnableEditButton();
	// </Kaze>
}
function EnableEditButton() {
	try {
		var url = GetDocumentUrl();
		var isBlank = ( (url == "about:blank") || (GetScheme(url) != "file") );
		var NsmTidyMenu = top.document.getElementById("NsmTidy");
		var NsmEditorMenu = top.document.getElementById("NsmEditor");
		var NsmEditButton = top.document.getElementById("NsmEditButton");
		NsmTidyMenu.disabled = isBlank;
		NsmTidyMenu.setAttribute("disabled", isBlank);
		NsmEditorMenu.disabled = isBlank;
		NsmEditorMenu.setAttribute("disabled", isBlank);
		NsmEditButton.disabled = isBlank;
	} catch (e) {}
}
//
function UpdateWindowTitle() { // editor.js
	var hideSource = false; // Kaze
	
	try {
		var windowTitle = GetDocumentTitle();
		if (!windowTitle)
			windowTitle = GetString("untitled");
		
		// Append just the 'leaf' filename to the Doc. Title for the window caption
		var docUrl = GetDocumentUrl();
		if (docUrl && !IsUrlAboutBlank(docUrl)) {
			var scheme = GetScheme(docUrl);
			var filename = GetFilename(docUrl);
			hideSource = /^\~/.test(filename);
			if (filename)
				windowTitle += " [" + scheme + ":/.../" + filename.replace(/^\~/, "") + "]"; // Kaze
				//~ windowTitle += " [" + scheme + ":/.../" + filename + "]";
			
			// Save changed title in the recent pages data in prefs
			SaveRecentFilesPrefs();
		}
		// Set window title with " - Composer" appended
		var xulWin = document.documentElement;
		window.title = windowTitle + xulWin.getAttribute("titlemenuseparator") + xulWin.getAttribute("titlemodifier");
	} catch (e) { dump(e); }
  
	// <Kaze>
	// hide source for splitted file
	var sourceTab = window.top.document.getElementById("SourceModeButton");
	sourceTab.setAttribute("disabled", hideSource);
	//~ sourceTab.setAttribute("hidden", hideSource);	
	var sourceCmd = window.top.document.getElementById("cmd_HTMLSourceMode");
	sourceCmd.setAttribute("hidden", hideSource);
	//~ sourceCmd.setAttribute("disabled", hideSource);
	
	//~ var isBlank = ( (docUrl == "about:blank") || (GetScheme(docUrl) != "file") );
	EnableEditButton();
	hcModif.check(docUrl);
	//~ window.addEventListener("blur", EditorOnBlur, false);
	//~ GetCurrentEditor.addEventListener("blur", EditorOnBlur, false);
	//~ xulWin.setAttribute("onblur", "EditorOnBlur()");
	//~ document.getElementById("editorWindow").setAttribute("onblur", "EditorOnBlur()");
	//~ document.getElementById("editorWindow").addEventListener("blur", EditorOnBlur, false);
	//~ document.getElementById("tabeditor").addEventListener("blur", EditorOnBlur, false);
	// </Kaze>
}


// throws an error or returns true if user attempted save; false if user canceled save
/* function SaveDocument(aSaveAs, aSaveCopy, aMimeType)
{
  var editor = GetCurrentEditor();
  if (!aMimeType || aMimeType == "" || !editor)
    throw NS_ERROR_NOT_INITIALIZED;

  var editorDoc = editor.document;
  if (!editorDoc)
    throw NS_ERROR_NOT_INITIALIZED;

  // if we don't have the right editor type bail (we handle text and html)
  var editorType = GetCurrentEditorType();
  if (editorType != "text" && editorType != "html" 
      && editorType != "htmlmail" && editorType != "textmail")
    throw NS_ERROR_NOT_IMPLEMENTED;

  var saveAsTextFile = IsSupportedTextMimeType(aMimeType);

  // check if the file is to be saved is a format we don't understand; if so, bail
  if (aMimeType != "text/html" && !saveAsTextFile &&
      aMimeType != "application/xhtml+xml" && aMimeTYpe != "text/xml")
    throw NS_ERROR_NOT_IMPLEMENTED;

  if (saveAsTextFile)
    aMimeType = "text/plain";

  var urlstring = GetDocumentUrl();
  var mustShowFileDialog = (aSaveAs || IsUrlAboutBlank(urlstring) || (urlstring == ""));

  // If editing a remote URL, force SaveAs dialog
  if (!mustShowFileDialog && GetScheme(urlstring) != "file")
    mustShowFileDialog = true;

  var replacing = !aSaveAs;
  var titleChanged = false;
  var doUpdateURI = false;
  var tempLocalFile = null;

  if (mustShowFileDialog)
  {
	  try {
	    // Prompt for title if we are saving to HTML
	    if (!saveAsTextFile && (editorType == "html"))
	    {
	      var userContinuing = PromptAndSetTitleIfNone(); // not cancel
	      if (!userContinuing)
	        return false;
	    }

	    var dialogResult = PromptForSaveLocation(saveAsTextFile, editorType, aMimeType, urlstring);
	    if (dialogResult.filepickerClick == nsIFilePicker.returnCancel)
	      return false;

	    replacing = (dialogResult.filepickerClick == nsIFilePicker.returnReplace);
	    urlstring = dialogResult.resultingURIString;
	    tempLocalFile = dialogResult.resultingLocalFile;
 
      // update the new URL for the webshell unless we are saving a copy
      if (!aSaveCopy)
        doUpdateURI = true;
   } catch (e) {  return false; }
  } // mustShowFileDialog

  var success = true;
  var ioService;
  try {
    // if somehow we didn't get a local file but we did get a uri, 
    // attempt to create the localfile if it's a "file" url
    var docURI;
    if (!tempLocalFile)
    {
      ioService = GetIOService();
      docURI = ioService.newURI(urlstring, editor.documentCharacterSet, null);
      
      if (docURI.schemeIs("file"))
      {
        var fileHandler = GetFileProtocolHandler();
        tempLocalFile = fileHandler.getFileFromURLSpec(urlstring).QueryInterface(Components.interfaces.nsILocalFile);
      }
    }

    // this is the location where the related files will go
    var relatedFilesDir = null;
    
    // First check pref for saving associated files
    var saveAssociatedFiles = false;
    try {
      var prefs = GetPrefs();
      saveAssociatedFiles = prefs.getBoolPref("editor.save_associated_files");
    } catch (e) {}

    // Only change links or move files if pref is set 
    //  and we are saving to a new location
    if (saveAssociatedFiles && aSaveAs)
    {
      try {
        if (tempLocalFile)
        {
          // if we are saving to the same parent directory, don't set relatedFilesDir
          // grab old location, chop off file
          // grab new location, chop off file, compare
          var oldLocation = GetDocumentUrl();
          var oldLocationLastSlash = oldLocation.lastIndexOf("\/");
          if (oldLocationLastSlash != -1)
            oldLocation = oldLocation.slice(0, oldLocationLastSlash);

          var relatedFilesDirStr = urlstring;
          var newLocationLastSlash = relatedFilesDirStr.lastIndexOf("\/");
          if (newLocationLastSlash != -1)
            relatedFilesDirStr = relatedFilesDirStr.slice(0, newLocationLastSlash);
          if (oldLocation == relatedFilesDirStr || IsUrlAboutBlank(oldLocation))
            relatedFilesDir = null;
          else
            relatedFilesDir = tempLocalFile.parent;
        }
        else
        {
          var lastSlash = urlstring.lastIndexOf("\/");
          if (lastSlash != -1)
          {
            var relatedFilesDirString = urlstring.slice(0, lastSlash + 1);  // include last slash
            ioService = GetIOService();
            relatedFilesDir = ioService.newURI(relatedFilesDirString, editor.documentCharacterSet, null);
          }
        }
      } catch(e) { relatedFilesDir = null; }
    }

    var destinationLocation;
    if (tempLocalFile)
      destinationLocation = tempLocalFile;
    else
      destinationLocation = docURI;

    success = OutputFileWithPersistAPI(editorDoc, destinationLocation, relatedFilesDir, aMimeType);
  }
  catch (e)
  {
    success = false;
  }

  if (success)
  {
    try {
      if (doUpdateURI)
      {
         // If a local file, we must create a new uri from nsILocalFile
        if (tempLocalFile)
          docURI = GetFileProtocolHandler().newFileURI(tempLocalFile);

        // We need to set new document uri before notifying listeners
        SetDocumentURI(docURI);
      }

      // Update window title to show possibly different filename
      // This also covers problem that after undoing a title change,
      //   window title loses the extra [filename] part that this adds
      UpdateWindowTitle();

      if (!aSaveCopy)
        editor.resetModificationCount();
      // this should cause notification to listeners that document has changed

      // Set UI based on whether we're editing a remote or local url
      SetSaveAndPublishUI(urlstring);
      
      // Kaze : tidy page here
    } catch (e) {}
  }
  else
  {
    var saveDocStr = GetString("SaveDocument");
    var failedStr = GetString("SaveFileFailed");
    AlertWithTitle(saveDocStr, failedStr);
  }
  return success;
}
 */